package test;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Properties;

import javax.jdo.Extent;
import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManager;
import javax.jdo.PersistenceManagerFactory;
import javax.jdo.Query;
import javax.jdo.Transaction;

public class Test {
	private static void delete() {
		try {
			Properties props = new Properties();
			props.load(new FileInputStream("C:\\JDOConfig.properties"));
			PersistenceManagerFactory pmfactory = JDOHelper.getPersistenceManagerFactory(props);
			PersistenceManager pm = pmfactory.getPersistenceManager();
			Transaction tx = pm.currentTransaction();
			tx.begin();
			T1 r = (T1)pm.getObjectById(new T1PK(777), false);
			pm.deletePersistent(r);
			tx.commit();
			pm.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	private static void insert() {
		try {
			Properties props = new Properties();
			props.load(new FileInputStream("C:\\JDOConfig.properties"));
			PersistenceManagerFactory pmfactory = JDOHelper.getPersistenceManagerFactory(props);
			PersistenceManager pm = pmfactory.getPersistenceManager();
			Transaction tx = pm.currentTransaction();
			tx.begin();
			T1 r = new T1();
			r.setF1(777);
			r.setF2("J test");
			pm.makePersistent(r);
			tx.commit();
			pm.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	private static void selectone() {
		try {
			Properties props = new Properties();
			props.load(new FileInputStream("C:\\JDOConfig.properties"));
			PersistenceManagerFactory pmfactory = JDOHelper.getPersistenceManagerFactory(props);
			PersistenceManager pm = pmfactory.getPersistenceManager();
			Transaction tx = pm.currentTransaction();
			tx.begin();
			T1 r = (T1)pm.getObjectById(new T1PK(777), false);
			System.out.println(r.getF1() + " " + r.getF2());
			tx.commit();
			pm.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	private static void selectall() {
		try {
			Properties props = new Properties();
			props.load(new FileInputStream("C:\\JDOConfig.properties"));
			PersistenceManagerFactory pmfactory = JDOHelper.getPersistenceManagerFactory(props);
			PersistenceManager pm = pmfactory.getPersistenceManager();
			Transaction tx = pm.currentTransaction();
			tx.begin();
			Extent all = pm.getExtent(T1.class, false);
			Iterator it = all.iterator();
			while(it.hasNext()) {
				T1 r = (T1)it.next();
				System.out.println(r.getF1() + " " + r.getF2());
			}
			tx.commit();
			pm.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	private static void selectsome() {
		try {
			Properties props = new Properties();
			props.load(new FileInputStream("C:\\JDOConfig.properties"));
			PersistenceManagerFactory pmfactory = JDOHelper.getPersistenceManagerFactory(props);
			PersistenceManager pm = pmfactory.getPersistenceManager();
			Transaction tx = pm.currentTransaction();
			tx.begin();
			Extent all = pm.getExtent(T1.class, false);
			Query q = pm.newQuery(all, "!f2.startsWith(\"Dette\")");
			Collection col = (Collection)q.execute();
			Iterator it = col.iterator();
			while(it.hasNext()) {
				T1 r = (T1)it.next();
				System.out.println(r.getF1() + " " + r.getF2());
			}
			tx.commit();
			pm.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
    public static void main(String[] args) {
    	delete();
		insert();
		selectone();  
		selectall();  	
		selectsome();
    }
}